#!/bin/bash

    myVersion="$2"
#Sign
    rsync -avx bin/bncsql-$myVersion-release-unsigned.apk 10.0.0.250:/tmp/bncsql-$myVersion-unsigned-unaligned.apk		|| exit 1
    ssh 10.0.0.250 /etc/apksigner/apksigner /tmp/bncsql-$myVersion-unsigned-unaligned.apk /tmp/bncsql-$myVersion-unaligned.apk	|| exit 1
    rsync -avx 10.0.0.250:/tmp/bncsql-$myVersion-unaligned.apk bin/bncsql-$myVersion-unaligned.apk				|| exit 1

#zipalign
    my_In="bin/bncsql-$myVersion-unaligned.apk"
    myOut="bin/bncsql-$myVersion.apk"
    PATH+=:/opt/android-sdk-21/build-tools/21.1.2
    zipalign -f -v 4 $my_In $myOut	|| exit 1
    zipalign -c -v 4 $myOut		|| exit 1
    echo "zipalign done"
    install -pm 444 $myOut $pacdir
    adb install -r $myOut || exit 1
    echo "done"
    ./tools/apk2dir $myOut
