//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <python2.7/Python.h>
#include <libgen.h> //4 dirname !!!


int main(int argc, char *argv[]) {
// /opt/bncsql-osx-x86_64/bncsql.app/Contents/bin
// /opt/bncsql-osx-x86_64/bncsql.app/Contents/Resources/kivy
// /opt/bncsql-osx-x86_64/bncsql.app/Contents/Frameworks
int  ret            =  0;
char pythPath[1024] = "";
char kivyPath[1024] = "";
char app_Path[1024] = "";

    strcpy  ( app_Path, dirname ( argv[0] ) );
    //printf  ( "app_Path=%s\n", app_Path ); fflush ( stdout );
    if ( strcmp ( app_Path, "." ) == 0 ) {
    char Pwd[255];
    int  PwdLen = 254;
	getcwd ( Pwd, PwdLen );
	strcpy ( app_Path, Pwd );
    }//if ( strcmp ( app_Path, "." ) == 0 )
    //printf  ( "app_Path=%s\n", app_Path ); fflush ( stdout );
    strcpy ( app_Path, dirname ( app_Path ) );
    //printf  ( "app_Path=%s\n", app_Path ); fflush ( stdout );
    strcpy  ( kivyPath, app_Path );
    strcat  ( app_Path, "/Resources/bin"  );
    strcat  ( kivyPath, "/Resources/kivy" );
    sprintf ( pythPath, "%s:%s:%s", app_Path, kivyPath, Py_GetPath () );
    //printf  ( "pythPath=%s\n", pythPath ); fflush ( stdout );

//Python
    //putenv ( "PYTHONOPTIMIZE=2"          );
    //putenv ( "PYTHONDONTWRITEBYTECODE=1" );
    //putenv ( "PYTHONNOUSERSITE=1"        );
    //putenv ( "PYTHONPATH=."              );
    //putenv ( "PYTHONVERBOSE=1"           );//bug4debug
    //putenv ( "KIVY_BUILD=myxxxos"        );
    //putenv ( "KIVY_NO_CONFIG=1"          );
    //putenv ( "KIVY_NO_FILELOG=1"         );
    //putenv ( "KIVY_WINDOW=sdl2"          );
    //putenv ( "KIVY_IMAGE=imageio,tex"    );
    //putenv ( "KIVY_AUDIO=sdl2"           );
    //#ifndef DEBUG
    // putenv ( "KIVY_NO_CONSOLELOG=1"     );
    //#endif
    //Py_SetPythonHome ( "/opt/bncsql-linux-x86_64/bin" ); //bug4debug
    chdir   ( app_Path );
    Py_Initialize();
    PySys_SetArgv(argc, argv);
    PySys_SetPath ( pythPath );
    PyEval_InitThreads();
char *prog = "main.pyc";
    FILE* fd = fopen(prog, "r");
    if ( fd == NULL ) { ret = 1; }
    else              { ret = PyRun_SimpleFileEx(fd, prog, 1); }
    Py_Finalize();

    return ret;

} //int main(int argc, char *argv[])
