//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <Python.h>
#ifdef WIN32
#	include <direct.h> //getcwd
#endif
#include <libgen.h> //4 dirname !!!
#include <unistd.h> //sleep

int main(int argc, char *argv[]) {
// /opt/bncsql-osx-x86_64/bncsql.app/Contents/bin
// /opt/bncsql-osx-x86_64/bncsql.app/Contents/Resources/kivy
// /opt/bncsql-osx-x86_64/bncsql.app/Contents/Frameworks
int  ret            =  0;
char pythPath[1024] = "";
char kivyPath[1024] = "";
char app_Path[1024] = "";

//Python
    //putenv ( "PYTHONOPTIMIZE=2"          );
    //putenv ( "PYTHONDONTWRITEBYTECODE=1" );
    //putenv ( "PYTHONNOUSERSITE=1"        );
    //putenv ( "PYTHONPATH=."              );
    //putenv ( "PYTHONVERBOSE=1"           );//bug4debug, 2do no change
    //putenv ( "KIVY_BUILD=myxxxos"        );
    //putenv ( "KIVY_NO_CONFIG=1"          );
    //putenv ( "KIVY_NO_FILELOG=1"         );
    //putenv ( "KIVY_WINDOW=sdl2"          );
    //putenv ( "KIVY_IMAGE=imageio,tex"    );
    //putenv ( "KIVY_AUDIO=sdl2"           );
    //#ifndef DEBUG
    // putenv ( "KIVY_NO_CONSOLELOG=1"     );
    //#endif
    //Py_SetPythonHome ( "/opt/bncsql-linux-x86_64/bin" ); //bug4debug

    strcpy  ( app_Path, dirname ( argv[0] ) );
    printf  ( "app_Path1=%s\n", app_Path ); fflush ( stdout );
    if ( strcmp ( app_Path, "." ) == 0 ) {
    char Pwd[255];
    int  PwdLen = 254;
	getcwd ( Pwd, PwdLen );
	strcpy ( app_Path, Pwd );
    }//if ( strcmp ( app_Path, "." ) == 0 )
    printf  ( "app_Path2=%s\n", app_Path ); fflush ( stdout );

char  *Path = NULL;
    Path = getenv ("PATH");
char sysCmd[1024] = "";
char          SetPath[2048] = "";
    sprintf ( SetPath, "%s%s\\SDL2\\bin;", SetPath, app_Path );
    sprintf ( sysCmd, "PATH=%s;%s", Path, SetPath     );
    printf  ( "sysCmd=%s\n", sysCmd ); fflush ( stdout );
    putenv  ( sysCmd );

char pythHome[1024] = "";
    sprintf ( pythHome, "%s\\Python27", app_Path );
    Py_SetPythonHome ( pythHome );
    printf ( "Py_GetPath ()=%s\n", Py_GetPath () );
    //printf  ( "app_Path=%s\n", app_Path ); fflush ( stdout );
              kivyPath[0] = 0;
    sprintf ( kivyPath, "%s%s\\kivy27;"     , kivyPath, app_Path );
    strcat  ( app_Path, "\\bin"  );

    sprintf ( pythPath, "%s;%s;%s", app_Path, kivyPath, Py_GetPath () );
    printf  ( "pythPath=%s\n", pythPath ); fflush ( stdout );

    chdir   ( app_Path );

    Py_Initialize();
    PySys_SetArgv(argc, argv);
    PySys_SetPath ( pythPath );
    PyEval_InitThreads();
    //printf ( "Py_GetPath ()=%s= !!!!\n", Py_GetPath () ); fflush ( stdout );
    //system  ( "dir"  );
//2do char *prog = "main.pyc";
//2do     FILE* fd = fopen(prog, "r");
//2do     if ( fd == NULL ) {
//2do 	ret = 1;
//2do 	printf ( "ret=%ld\n", ret ); fflush ( stdout );
//2do     }
//2do     else              {
//2do 	printf ( "call PyRun_SimpleFileEx\n" ); fflush ( stdout );
//2do 	ret = PyRun_SimpleFileEx(fd, prog, 1);
//2do 	printf ( "ret=%ld\n", ret ); fflush ( stdout );
//2do     }
//kivy start ok
    PyRun_SimpleString ( "from main import MainStart\nMainStart()\n" );

    Py_Finalize();

    //sleep(60); //bug4debug
    return ret;

} //int main(int argc, char *argv[])
