#Copyright 2017 blacknoise.at
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
import logging


def bnlog_init ( log_file ):
    logging.info ( "bnlog_init test call" )
    #print "logging.root.handlers[0]=" + str ( len (logging.root.handlers ) )
    for xxx in logging.root.handlers:
	#print "logging.root.handlers[0]=" + str ( xxx )
	xxx.setFormatter ( logging.Formatter ( '%(levelname)8s %(asctime)15s %(filename)15s:%(lineno)4s:%(funcName)15s() %(message)s' ) )
    logger = logging.getLogger ()
    #logger.setLevel ( logging.CRITICAL )
    #logger.setLevel ( logging.ERROR    )
    #logger.setLevel ( logging.WARNING  )
    logger.setLevel  ( logging.INFO     )
    #logger.setLevel ( logging.DEBUG    )
    #logger.setLevel ( logging.NOTSET   )
    logging.info  ( "bnlog_init test info"  )
    logging.debug ( "bnlog_init test debug" )


bnlog_init ( "" )
