#!/bin/bash
#Version: 1.0.1

    cd $(dirname $0)
    echo "$0 Install -> $1"
    rmdir $1/bin/CMakeFiles

    [ -e $1/Python27 ] && exit 0 #already installed

    srcDir="/opt/i686-w64-mingw32/Kivy-1.9.0-py2.7-win32-x86"
    dstDir="$1/bin"
    dstDir="$1"
    mkdir -p  $dstDir || exit 1
    for libFile in `cat kivy.files` ; do
	#echo $libFile
	libDir=`dirname $libFile`
	libDir=$(echo $libDir | sed 's@MinGW/bin@/bin@g')
	test -e                  $dstDir/$libDir/$libFile && break
	mkdir -p                 $dstDir/$libDir || exit 1
	cp -pPv $srcDir/$libFile $dstDir/$libDir || exit 1
    done
